﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace $safeprojectname$
{
    public partial class ResultContextMenu : UserControl
    {

        private ResultContainer _Parent;
        private TreeViewItem _Item;

        #region Public Methods
        public ResultContextMenu()
        {
            InitializeComponent();
            btnZoom.Click += btnZoom_Click;
            btnPan.Click += btnPan_Click;
            btnIdentify.Click += btnIdentify_Click;
            btnUnselect.Click += btnUnselect_Click;
            btnDelete.Click += btnDelete_Click;
            btnCancel.Click += btnCancel_Click; 
            this.KeyDown += UserControl_KeyDown;
        }

        public void SetParent(ResultContainer TheParent)
        {
            _Parent = TheParent;
        }

        public void SetItem(TreeViewItem TheItem)
        {
            _Item = TheItem;
        }
        #endregion

        #region Handlers

        private void btnZoom_Click(Object sender, RoutedEventArgs e)
        {
            _Parent.ZoomItem(_Item);
        }

        private void btnPan_Click(Object sender, RoutedEventArgs e)
        {
            _Parent.PanItem(_Item);
        }

        private void btnIdentify_Click(Object sender, RoutedEventArgs e)
        {
            _Parent.IdentifyItem(_Item);
        }

        private void btnUnselect_Click(Object sender, RoutedEventArgs e)
        {
            _Parent.UnselectItem(_Item);
        }

        private void btnDelete_Click(Object sender, RoutedEventArgs e)
        {
            _Parent.DeleteItem(_Item);
        }

        private void btnCancel_Click(Object sender, RoutedEventArgs e)
        {
            _Parent.CancelItem();
        }

        private void UserControl_KeyDown(Object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Escape)
                _Parent.CancelItem();
        }
        #endregion
    }
}
