﻿Imports ESRI.ArcGIS.Client

Public Enum MouseCursorType
    None = 0
    ZoomIn = 1
    ZoomOut = 2
    Pan = 3
    Identify = 4
    Measure = 5
End Enum

Partial Public Class MouseCursor
    Inherits UserControl

    Private _Parent As MainPage
    Private _Map As Map
    Private _bActive As Boolean = False
    Private _bInMap As Boolean = False
    Private _ptHotSpot As Point
    Private _ptSize As Point

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Sub SetParent(ByVal TheParent As MainPage)
        _Parent = TheParent
        'AddHandler _Parent.MouseEnter, AddressOf _Parent_MouseEnter
        AddHandler _Parent.MouseMove, AddressOf _Parent_MouseMove
        'AddHandler _Parent.MouseLeave, AddressOf _Parent_MouseLeave
    End Sub

    Public Sub SetMap(ByVal TheMap As Map)
        _Map = TheMap
        AddHandler _Map.MouseEnter, AddressOf _Map_MouseEnter
        AddHandler _Map.MouseLeave, AddressOf _Map_MouseLeave
    End Sub

    Public Sub SetCursor(ByVal mcType As MouseCursorType)
        Select Case mcType
            Case MouseCursorType.None
                _bActive = False
                _Parent.Cursor = Cursors.Arrow
                Me.Visibility = Visibility.Collapsed
            Case MouseCursorType.ZoomIn
                _bActive = True
                CursorZoomIn.Visibility = Visibility.Visible
                SetHotspot(CursorZoomIn)
                CursorZoomOut.Visibility = Visibility.Collapsed
                CursorPan.Visibility = Visibility.Collapsed
                CursorIdentify.Visibility = Visibility.Collapsed
                CursorMeasure.Visibility = Visibility.Collapsed
            Case MouseCursorType.ZoomOut
                _bActive = True
                CursorZoomIn.Visibility = Visibility.Collapsed
                CursorZoomOut.Visibility = Visibility.Visible
                SetHotspot(CursorZoomOut)
                CursorPan.Visibility = Visibility.Collapsed
                CursorIdentify.Visibility = Visibility.Collapsed
                CursorMeasure.Visibility = Visibility.Collapsed
            Case MouseCursorType.Pan
                _bActive = True
                CursorZoomIn.Visibility = Visibility.Collapsed
                CursorZoomOut.Visibility = Visibility.Collapsed
                CursorPan.Visibility = Visibility.Visible
                SetHotspot(CursorPan)
                CursorIdentify.Visibility = Visibility.Collapsed
                CursorMeasure.Visibility = Visibility.Collapsed
            Case MouseCursorType.Identify
                _bActive = True
                CursorZoomIn.Visibility = Visibility.Collapsed
                CursorZoomOut.Visibility = Visibility.Collapsed
                CursorPan.Visibility = Visibility.Collapsed
                CursorIdentify.Visibility = Visibility.Visible
                SetHotspot(CursorIdentify)
                CursorMeasure.Visibility = Visibility.Collapsed
            Case MouseCursorType.Measure
                _bActive = True
                CursorZoomIn.Visibility = Visibility.Collapsed
                CursorZoomOut.Visibility = Visibility.Collapsed
                CursorPan.Visibility = Visibility.Collapsed
                CursorIdentify.Visibility = Visibility.Collapsed
                CursorMeasure.Visibility = Visibility.Visible
                SetHotspot(CursorMeasure)
        End Select
    End Sub

    'Private Sub _Parent_MouseEnter(ByVal sender As Object, ByVal args As System.Windows.Input.MouseEventArgs)
    '    If Not _bActive Then
    '        Exit Sub
    '    End If
    '    _Parent.Cursor = Cursors.None
    '    Me.Visibility = Visibility.Visible
    '    MoveTo(args)
    'End Sub

    Private Sub _Parent_MouseMove(ByVal sender As Object, ByVal args As System.Windows.Input.MouseEventArgs)
        If Not _bActive Then
            Exit Sub
        End If
        If Not _bInMap Then
            Exit Sub
        End If
        MoveTo(args)
    End Sub

    'Private Sub _Parent_MouseLeave(ByVal sender As Object, ByVal args As System.Windows.Input.MouseEventArgs)
    '    If Not _bActive Then
    '        Exit Sub
    '    End If
    '    Me.Visibility = Visibility.Collapsed
    'End Sub

    Private Sub _Map_MouseEnter(ByVal sender As Object, ByVal args As System.Windows.Input.MouseEventArgs)
        If Not _bActive Then
            Exit Sub
        End If
        _bInMap = True
        _Parent.Cursor = Cursors.None
        Me.Visibility = Visibility.Visible
        MoveTo(args)
    End Sub

    Private Sub _Map_MouseLeave(ByVal sender As Object, ByVal args As System.Windows.Input.MouseEventArgs)
        If Not _bActive Then
            Exit Sub
        End If
        _bInMap = False
        _Parent.Cursor = Cursors.Arrow
        Me.Visibility = Visibility.Collapsed
    End Sub

    Private Sub SetHotspot(ByVal img As Image)
        Dim sTag As String = img.Tag.ToString()
        Dim Tokens() As String = sTag.Split(":")
        Dim Point() As String = Tokens(1).Split(",")
        _ptHotSpot.X = CInt(Point(0))
        _ptHotSpot.Y = CInt(Point(1))
        _ptSize.X = img.Width
        _ptSize.Y = img.Height
    End Sub

    Private Sub MoveTo(ByVal args As System.Windows.Input.MouseEventArgs)
        Dim pt2 As Point = args.GetPosition(Me)
        GridTransform.X = pt2.X - _ptHotSpot.X - ((32 - _ptSize.X) / 2)
        GridTransform.Y = pt2.Y - _ptHotSpot.Y - ((32 - _ptSize.Y) / 2)
    End Sub

End Class
